<?php
/**
 * Created by PhpStorm.
 * User: SysWork
 * Date: 30/08/2018
 * Time: 4:12 PM
 */

class Usuarios_model extends CI_Model
{
    public $cod_user;
    public $nombres;
    public $apellidos;
    public $login;
    public $pass;
    public $mail_user;
    public $estado_user = 1;
    public $ide_rol;
    public $editable = "S";
    public $ide_funcionario = "1";
    public $config_users;

    public function __construct()
    {
        parent::__construct();
    }

    public function set_data($data_form)
    {
        foreach ($data_form as $campo => $valor) {
            if (property_exists("Usuarios_model", $campo)) {
                $this->$campo = $valor;
            }
        }
        return $this;
    }

    private function error()
    {
        return $this->db->error();
    }

    public function insert()
    {
        $rta = $this->db->insert('seg_usuarios', $this);
        #echo '---'.$this->db->last_query();
        if ($rta) {
            $respuesta = [
                "error" => false,
                'msg' => "Registro guardado correctamente",
                'cd_user' => $this->db->insert_id()
            ];
        } else {
            $respuesta = [
                "error" => true,
                'msg' => "Error al guardar nuevo registro",
                'error_msg' => $this->error(),
                'error_num' => $this->error()
            ];
        }
        return $respuesta;
    }

    public function update()
    {
        unset($this->pass);
        $this->db->where('cod_user', $this->cod_user);
        $rta = $this->db->update('seg_usuarios', $this);
        #echo $this->db->last_query();
        if ($rta) {
            $respuesta = [
                "error" => false,
                'msg' => "Registro guardado correctamente",
                'cd_user' => $this->cod_user
            ];
        } else {
            $respuesta = [
                "error" => true,
                'msg' => "Error al guardar nuevo registro",
                'error_msg' => $this->error(),
                'error_num' => $this->error()
            ];
        }
        return $respuesta;
    }

    public function eliminar($codigo)
    {
        $this->db->set('estado_user', false);
        $this->db->where('cod_user', $codigo);
        $rta = $this->db->update('seg_usuarios');

        if ($rta) {
            return true;
        } else {
            $error = $this->db->error();
            throw new Exception($error['message'], $error['code']);
        }
    }
}